//-----------------------------------------------------------------------
// Copyright (c) 2017 Snap Inc.
//-----------------------------------------------------------------------

#define SC_USE_USER_DEFINED_VS_MAIN

#include <std.glsl>
#include <std_vs.glsl>
#include <std_fs.glsl>
#include <std_texture.glsl>

#ifndef saturate // HACK 05/15/2019: SAMPLETEX() uses saturate(), but core doesn't define it. This can be removed after Core 10.59.
#define saturate(A) clamp(A, 0.0, 1.0)
#endif


#ifdef VERTEX_SHADER

void main(void) {
    sc_Vertex_t v = sc_LoadVertexAttributes();
    sc_ProcessVertex(v);
}

#endif // #ifdef VERTEX_SHADER

#ifdef FRAGMENT_SHADER

DECLARE_TEXTURE(opacityTex)

void main(void) {
    vec4 surfaceColor = vec4(1.0);

#ifdef sc_ProjectiveShadowsReceiver
    surfaceColor.rgb *= evaluateShadow();
#endif // sc_ProjectiveShadowsReceiver

#if defined(ENABLE_OPACITY_TEX)
    SAMPLE_TEX(opacityTex, varTex0, 0.0);
    surfaceColor = mix(vec4(1.0), surfaceColor, opacityTexSample.r);
#endif

    gl_FragColor = surfaceColor;
}

#endif //FRAGMENT SHADER
